#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
#include "graph.h"
#include "iterator.h"
#include "nodes.h"

//FIXME: for power law... we don't know m.
graph *empty_graph (node_id n, node_id m) {
  graph *g;
  int i;

  assert( (g = (graph *)malloc(sizeof(graph))) != NULL );
  g->n = n;
  g->m = m;
  assert( (g->adjacencies = (struct bst_node **)malloc(n*sizeof(struct bst_node*))) != NULL);
  for(i=0;i<n;i++)
    g->adjacencies[i] = NULL;
  g->linklistleft = (node_id *)malloc(m*sizeof(node_id));
  g->linklistright = (node_id *)malloc(m*sizeof(node_id));

  return(g);
}

graph *empty_graph_gnp (node_id n, node_id m) {
  graph *g;
  int i;

  assert( (g = (graph *)malloc(sizeof(graph))) != NULL );
  g->n = n;
  g->m = m;
  assert( (g->adjacencies = (struct bst_node **)malloc(n*sizeof(struct bst_node*))) != NULL);
  for(i=0;i<n;i++)
    g->adjacencies[i] = NULL;
  g->linklistleft = (node_id *)malloc(n*(n-1)*sizeof(node_id));
  g->linklistright = (node_id *)malloc(n*(n-1)*sizeof(node_id));

  return(g);
}

void free_graph (graph *g) {
  struct bst_node *n;
  queue *q;
  node_id i;

  for(i=0;i<g->n;i++){
    q = iterate_init(g->adjacencies[i], g->n);
    n = iterate_next_node(q);
    while( n != NULL ){
      free (n);
      n = iterate_next_node(q);
    }
    iterate_end(q);
  }
  free(g->adjacencies);
  free(g->linklistleft);
  free(g->linklistright);
  free(g);
}

void print_graph (graph* g) {
  queue *q;
  struct bst_node *n;
  node_id i,v;

  for(i=0;i<g->n;i++){
    q = iterate_init(g->adjacencies[i],g->n);
    n = iterate_next_node(q);
    while( n != NULL ){
      v=n->data;
      if( i < v )
	printf("%ld %ld\n",i,v);
      n = iterate_next_node(q);
    }
    iterate_end(q);
  }
}

//think about inline functions
void remove_link (graph *g, long link) {
  struct bst_node **search_result;
  node_id a, b;

  a = g->linklistleft[link];
  b = g->linklistright[link];

  search_result = search (g->adjacencies+a,b);
  delete (search_result);

  search_result = search (g->adjacencies+b,a);
  delete (search_result);
}


// todo: inline maybe???
// return 1 if link was added,
//        0 otherwise.
int add_link (graph *g, long link_id, node_id a, node_id b) {
  int inserted = insert_count (g->adjacencies + a, b);
  if (inserted) {
    insert (g->adjacencies + b, a);
    if (a < b) {
      g->linklistleft[link_id]  = a;
      g->linklistright[link_id] = b;
    }
    else{
      g->linklistleft[link_id]  = b;
      g->linklistright[link_id] = a;
    }
  }
  return (inserted);
}
