#include "types.h"

struct link* iterate_next_link (queue *q);

// for the following collections of nodes
// we use the binary tree

struct link {
  // we assume that a <= b.
  node_id a, b; 
  struct link* left;
  struct link* right;
};

struct link* new_link(node_id a, node_id b);
struct link** search_link(struct link** links, node_id a, node_id b);
int insert_link_count(struct link** links, node_id a, node_id b);
void links_union(struct link** links_seen, long* nb_links_seen, 
                 struct link** p_links_seen, long nb_links_seen_part);
void clear_link_set(struct link** set1, node_id size1);
void free_link_set(struct link** set1, node_id size1);
void save_links(struct link** links, long nb_links, FILE* file);
