#include "types.h"

struct bst_node *iterate_next_node (queue *q);

// for the following collections of nodes
// we use the binary tree

struct bst_node {
  node_id data;
  struct bst_node* left;
  struct bst_node* right;
};

struct bst_node* new_bst_node(node_id data);
struct bst_node** search(struct bst_node** root, node_id data);
void free_set(struct bst_node **set1, node_id size1);

void insert(struct bst_node** root, node_id data);
int insert_count(struct bst_node** root, node_id data);
void delete(struct bst_node** node);

void nodes_union(struct bst_node** nodes_seen, long* nb_nodes_seen,
                 struct bst_node** p_nodes, long nb_p_nodes);

void print_nodes(struct bst_node** p_nodes, long nb_p_nodes);



//list of nodes
typedef struct node_list {
  long nb_nodes;
  node_id* nodes;
} node_list;

void free_node_list(node_list *rlist);


typedef struct node_id_queue {
  node_id size;
  node_id *elts;
  node_id begin;
  node_id end;
} node_id_queue;



node_id_queue *empty_node_id_queue(node_id size);
void free_node_id_queue(node_id_queue *q);
int is_empty_node_id_queue(node_id_queue *q);
int is_full_node_id_queue(node_id_queue *q);
void node_id_queue_add(node_id_queue *q, node_id e);
node_id node_id_queue_get(node_id_queue *q);
