#include "queue.h"
#include <stdio.h>
#include <assert.h>
#include <stdlib.h>

/******** QUEUE functions - begin *********/

/* queue for pointers */

queue *empty_queue (long size) {
  queue *q;

  assert ((q=(queue *) malloc (sizeof (queue))) != NULL );
  q->size = size+1;
  assert ((q->elts = (void **) 
           malloc ((size+1)*sizeof (void *))) != NULL );
  q->begin = q->end = 0;
  return (q);
}

void free_queue (queue *q){
  assert ((q != NULL) && (q->elts != NULL) );
  free (q->elts);
  free (q);
}

int is_empty_queue (queue *q){
  return (q->begin == q->end);
}

int is_full_queue (queue *q){
  return (q->begin == (q->end+1)%q->size);
}

void queue_add (queue *q, void *e){
  assert (!is_full_queue (q));
  assert (q->end < q-> size);
  q->elts[q->end] = e;
  q->end++;
  q->end %= q->size;
}

void *queue_get (queue *q){
  void *r;

  assert (!is_empty_queue (q));
  r = q->elts[q->begin];
  q->begin++;
  q->begin %= q->size;
  return (r);
}
