#define _BSD_SOURCE //for random() and srandom()
#include <stdio.h>
#include <assert.h>
#include <stdlib.h>
#include <unistd.h>
#include <malloc.h>
#include <time.h>
#include <string.h>

#include "iterator.h"
#include "links.h"
#include "nodes.h"
#include "graph.h"
#include "graph-algo.h"
#include "er-graph.h"
#include "pl-graph.h"

void print_sizeof_asp_usp (graph* g, long nb_dest) {
  struct bst_node **dest_set, **p_nodes, **asp_nodes;
  struct link **p_links_seen;
  struct link **asp_links;

  node_id src;


  long nb_asp_links = 0;
  long nb_asp_nodes;
  long nb_nodes_seen_part;
  long nb_links_seen_part = 0;

  dest_set = gen_destinations(g, 1);

  assert( (p_links_seen = (struct link **)malloc(sizeof(struct link*))) != NULL );
  *p_links_seen = NULL;

  assert( (asp_links = (struct link **)malloc(sizeof(struct link*))) != NULL );
  *asp_links = NULL;

  long a = 0;
  long b = 0;
  for (a = 0; a < g->n; a++) {
    for (b = a + 1; b < g->n; b++) {
      src = a;
      (*dest_set)->data = b;

      asp_nodes = asp(g, src, dest_set, nb_dest, 
                      asp_links,
                      &nb_asp_nodes, &nb_asp_links);
      free_set(asp_nodes,g->n);
      
      
      p_nodes = usp(g, src, dest_set, nb_dest, p_links_seen, &nb_links_seen_part);
      nb_nodes_seen_part = nb_links_seen_part + 1;
      free_set(p_nodes, nb_nodes_seen_part);
      
      printf("%ld %ld   %ld %ld %ld %ld\n"
             ,g->n, g->m, nb_nodes_seen_part, nb_links_seen_part, nb_asp_nodes, nb_asp_links);

      clear_link_set(asp_links, nb_asp_links);
      clear_link_set(p_links_seen, nb_links_seen_part);
  
    }
  }

  free_set(dest_set, g->n);
  free(asp_links);
  free(p_links_seen);

}



int main(int argc, char** argv) {
  //TODO: just use another seed here.
  srandom(time(NULL) + getpid());

  mallopt(M_TRIM_THRESHOLD,-1);
  mallopt(M_MMAP_MAX,0);

  long n,m;

  if( argc != 3 ){
    fprintf(stderr, 
            "Usage: %s nb_nodes nb_links\n",argv[0]);
    exit(1);
  }

  sscanf(argv[1],"%ld",&n);
  sscanf(argv[2],"%ld",&m);

  //FIXME: for the moment there is only ER graph
  graph* g = gen_er_graph(n, m);
  int nb_dest = 1;
  print_sizeof_asp_usp(g, nb_dest);
  free_graph(g);

  return (0);
}

