#define _BSD_SOURCE //for random() and srandom()
#include <stdio.h>
#include <assert.h>
#include <stdlib.h>
#include <unistd.h>
#include <malloc.h>
#include <math.h>
#include <time.h>
#include <string.h>

#include "iterator.h"
#include "links.h"
#include "nodes.h"
#include "graph.h"
#include "graph-algo.h"
#include "er-graph.h"
#include "pl-graph.h"
#include "simulator.h"








node_id set_inter(struct bst_node **set1, struct bst_node **set2, node_id size1, node_id size2){
  queue *q1, *q2;
  struct bst_node *n1, *n2;
  node_id nb_nodes_inter, v1,v2;

  nb_nodes_inter = 0;
  q1 = iterate_init(*set1, size1);
  q2 = iterate_init(*set2, size2);
  n1 = iterate_next_node(q1);
  n2 = iterate_next_node(q2);
  while( (n1 != NULL) && (n2 != NULL) ){
    v1 = n1->data;
    v2 = n2->data;
    if( v1 < v2 )
      n1 = iterate_next_node(q1);
    else 
      if( v1 > v2 )
	n2 = iterate_next_node(q2);
      else{
	nb_nodes_inter++;
	n1 = iterate_next_node(q1);
	n2 = iterate_next_node(q2);
      }
  }
  iterate_end(q1);
  iterate_end(q2);
  return(nb_nodes_inter);
}


node_id set_inter_slow(struct bst_node **set1, struct bst_node **set2, node_id size1, node_id size2){
  queue *q1;
  struct bst_node *n1, **search_result;
  node_id nb_nodes_inter, v1;

  nb_nodes_inter = 0;
  q1 = iterate_init(*set1, size1);
  n1 = iterate_next_node(q1);
  while( n1 != NULL ){
    v1 = n1->data;
    search_result = search(set2, v1);
    if( *search_result != NULL )
      nb_nodes_inter++;
    n1 = iterate_next_node(q1);
  }
  iterate_end(q1);
  return(nb_nodes_inter);
}

node_id set_card(struct bst_node **set1, node_id size1){
  queue *q1;
  struct bst_node *n1;
  node_id nb_nodes;

  nb_nodes = 0;
  q1 = iterate_init(*set1, size1);
  n1 = iterate_next_node(q1);
  while( n1 != NULL ){
    nb_nodes++;
    /* printf("set_card, counting node: %ld\n", n1->data);  */
    n1 = iterate_next_node(q1);
  }
  iterate_end(q1);
  return(nb_nodes);
}

void print_set(struct bst_node **set1, node_id size1, char *message){
  queue *q1;
  struct bst_node *n1;
  node_id v1;

  q1 = iterate_init(*set1, size1);
  n1 = iterate_next_node(q1);
  printf("Printing set-- %s\n",message);
  while( n1 != NULL ){
    v1 = n1->data;
    printf("%ld ",v1);
    /* printf("set_card, counting node: %ld\n", n1->data);  */
    n1 = iterate_next_node(q1);
  }
  printf("\n--\n");
  iterate_end(q1);
}


//GRAPHS




void print_freqtable(long* table, long size) {
  printf("#node-id how-many-iter\n");
  for (long i = 0; i < size; i++) {
    if (table[i] > 0)
      printf("%ld %ld\n",i,table[i]);
  }
}



/*

TODO: to implement

typedef void (*change_function)(graph*);
typedef void (*calculate_props_functions)(graph* g, struct bst_node** dest_set, long nb_dest);

void run_experiment_new(graph* g, 
                     long nb_dest,
                     long nb_steps, 
                     calculate_props_functions calculate_props,
                     change_function change) {

  struct bst_node** dest_set;
  node_id src;

  dest_set = gen_destinations(g, nb_dest);
  src = gen_source(g);

  for (int cur_step = 0; cur_step < nb_steps; cur_step ++) {
    calculate_props(g, dest_set, nb_dest);
    change(g);
  }

  free_set(dest_set,nb_dest);  
}


void no_change(graph* g) {
  
}

*/


void main_surface(int argc, char **argv){
  long n, m, d;
  // n --- number of nodes in our G
  // m --- number of links in our G
  sscanf(argv[1],"%ld",&n);
  sscanf(argv[2],"%ld",&m);
  
  printf("#n  m  d  nb_nodes_in_USP  nb_asp  asp_links_count\n");

  int j;
  for (j = 0; j < 2000; j++ ) {
    for (d = 100; d <= 1000; d += 100) {
      print_sizeof_asp_usp(n, m, d);
    }
  }
  
}

void main_size_of_pl(int argc, char** argv) {
  long n;
  long m;

  sscanf(argv[1],"%ld",&n);
  sscanf(argv[2],"%ld",&m);
  for (int i=0; i < 2000; i++) {
    graph* g = gen_pl_graph(n, -2.3, m);
    free_graph(g);
  }
}




/// FIXME: think about 

  //  main_surface(argc, argv);
  //  main_pl_0swaps(argc, argv);
    //main_size_of_pl(argc, argv);
  //size of Pl graph in links 
  //  main_er(argc, argv);
